;Program Manager v2.0
;(c)2006 Robbie McElrath

;routines
get_cur:
	ld	hl,(page)
	ld	a,(cur)
	or	a \ jr z,chk_progmngr
	ld	b,a
get_cur_:
	push	bc
	call	getnext
	pop	bc
	djnz	get_cur_
chk_progmngr:
	push	hl
	ld	de,-6
	add	hl,de
	ld	b,(hl)
	ld	de,prog_name
chk_progmngr_:
	dec	hl
	ld	a,(de)
	cp	(hl) \ jr nz,chk_progmngr_good
	inc	de
	djnz	chk_progmngr_
	pop	hl
	scf
	ret
chk_progmngr_good:
	pop	hl
	or	a
	ret

getfirst:
	ld	hl,(ProgPtr)
	call	chk_good
	ret	nz

getnext:
; inputs: hl = vat entry of a program
;outputs: hl = vat entry of next valid program
	call	getnext_main
	ret	z ;quit with z set if no more progs
	call	chk_good
	jr	z,getnext ;loop if program is invalid
	ret	;quit if prog is valid (z is reset)

getprev:
	push	hl
	call	getfirst
	pop	de
	call	cphlde \ ret z
getprev_:
	ld	(getprevs),hl
	push	de
	call	getnext
	pop	de
	call	cphlde \ jr nz,getprev_
	ld	hl,(getprevs)
	or	1 ;reset zero flag
	ret

getnext_main:
	ld	de,6
	or	a
	sbc	hl,de
	ld	e,(hl)
	sbc	hl,de
	dec	hl
	ld	de,(pTemp)
	call	cphlde
	ret

chk_good:
	push	hl
	ld	a,(hl)
	and	$1F
	cp	5 \ jr z,chk_good2
	cp	6 \ jr nz,chk_bad
chk_good2:
	ld	de,-6
	add	hl,de
	ld	a,(hl)
	cp	1 \ jr nz,chk_good2_
	dec	hl
	ld	a,(hl)
	cp	$21 \ jr z,chk_bad
	cp	$23 \ jr z,chk_bad
chk_good2_:
	or	1
	pop	hl
	ret
chk_bad:
	cp	a
	pop	hl
	ret

name2op1:
	push	hl
	ld	a,(hl)
	and	$1F
	ld	(op1),a
	ld	de,-6
	add	hl,de
	ld	b,(hl)
	ld	de,op1
name2op1_:
	dec	hl
	inc	de
	ld	a,(hl)
	ld	(de),a
	djnz	name2op1_
	inc	de
	xor	a
	ld	(de),a
	rst	08h
	ld	a,(op2+1)
	or	$40
	ld	(op2+1),a
	pop	hl
	ret

cphlde:
	push	hl
	or	a
	sbc	hl,de
	pop	hl
	ret
